Distributed Treemap in JavaScript

Using ApexCharts with JavaScript

This Distributed Treemap example uses ApexCharts.js directly in JavaScript, with no wrapper component.

Install it with npm install apexcharts, then mount the chart with new ApexCharts(element, options).render().

JavaScript installation guide
var options = {
  series: [
    {
      data: [
        {
          x: 'node_modules',
          y: 428,
        },
        {
          x: 'assets',
          y: 213,
        },
        {
          x: '.git',
          y: 154,
        },
        {
          x: 'build',
          y: 96,
        },
        {
          x: 'vendor',
          y: 88,
        },
        {
          x: 'public',
          y: 61,
        },
        {
          x: 'src',
          y: 47,
        },
        {
          x: 'cache',
          y: 39,
        },
        {
          x: 'docs',
          y: 24,
        },
        {
          x: 'tests',
          y: 18,
        },
        {
          x: 'logs',
          y: 12,
        },
        {
          x: 'config',
          y: 6,
        },
      ],
    },
  ],
  legend: {
    show: false,
  },
  chart: {
    height: 350,
    type: 'treemap',
  },
  title: {
    text: 'Disk Usage by Folder (GB)',
    align: 'center',
  },
  colors: [
    '#3B93A5',
    '#F7B844',
    '#ADD8C7',
    '#EC3C65',
    '#CDD7B6',
    '#C1F666',
    '#D43F97',
    '#1E5D8C',
    '#421243',
    '#7F94B0',
    '#EF6537',
    '#C0ADDB',
  ],
  plotOptions: {
    treemap: {
      distributed: true,
      enableShades: false,
    },
  },
}

var chart = new ApexCharts(document.querySelector('#chart'), options)
chart.render()

Distributed Treemap in Vue

Using ApexCharts with Vue

This Distributed Treemap example wires ApexCharts into Vue through the vue3-apexcharts component.

Install it with npm install vue3-apexcharts apexcharts, then mount the chart with <apexchart type="..." :options="options" :series="series" />.

Vue charts guide
<template>
  <div>
    <div id="chart">
      <apexchart
        type="treemap"
        height="350"
        :options="chartOptions"
        :series="series"
      ></apexchart>
    </div>
  </div>
</template>

<script>
import VueApexCharts from 'vue-apexcharts'

export default {
  components: {
    apexchart: VueApexCharts,
  },
  data: function () {
    return {
      series: [
        {
          data: [
            {
              x: 'node_modules',
              y: 428,
            },
            {
              x: 'assets',
              y: 213,
            },
            {
              x: '.git',
              y: 154,
            },
            {
              x: 'build',
              y: 96,
            },
            {
              x: 'vendor',
              y: 88,
            },
            {
              x: 'public',
              y: 61,
            },
            {
              x: 'src',
              y: 47,
            },
            {
              x: 'cache',
              y: 39,
            },
            {
              x: 'docs',
              y: 24,
            },
            {
              x: 'tests',
              y: 18,
            },
            {
              x: 'logs',
              y: 12,
            },
            {
              x: 'config',
              y: 6,
            },
          ],
        },
      ],
      chartOptions: {
        legend: {
          show: false,
        },
        chart: {
          height: 350,
          type: 'treemap',
        },
        title: {
          text: 'Disk Usage by Folder (GB)',
          align: 'center',
        },
        colors: [
          '#3B93A5',
          '#F7B844',
          '#ADD8C7',
          '#EC3C65',
          '#CDD7B6',
          '#C1F666',
          '#D43F97',
          '#1E5D8C',
          '#421243',
          '#7F94B0',
          '#EF6537',
          '#C0ADDB',
        ],
        plotOptions: {
          treemap: {
            distributed: true,
            enableShades: false,
          },
        },
      },
    }
  },
}
</script>

<style>
#chart {
  max-width: 650px;
  margin: 35px auto;
}
</style>

Distributed Treemap in React

Using ApexCharts with React

This Distributed Treemap example wires ApexCharts into React through the react-apexcharts component.

Install it with npm install react-apexcharts apexcharts, then mount the chart with <Chart type="..." options={options} series={series} />.

React charts guide
import React from 'react'
import ReactApexChart from 'react-apexcharts'
import './styles.css'

const ApexChart = () => {
  const [state, setState] = React.useState({
    series: [
      {
        data: [
          {
            x: 'node_modules',
            y: 428,
          },
          {
            x: 'assets',
            y: 213,
          },
          {
            x: '.git',
            y: 154,
          },
          {
            x: 'build',
            y: 96,
          },
          {
            x: 'vendor',
            y: 88,
          },
          {
            x: 'public',
            y: 61,
          },
          {
            x: 'src',
            y: 47,
          },
          {
            x: 'cache',
            y: 39,
          },
          {
            x: 'docs',
            y: 24,
          },
          {
            x: 'tests',
            y: 18,
          },
          {
            x: 'logs',
            y: 12,
          },
          {
            x: 'config',
            y: 6,
          },
        ],
      },
    ],
    options: {
      legend: {
        show: false,
      },
      chart: {
        height: 350,
        type: 'treemap',
      },
      title: {
        text: 'Disk Usage by Folder (GB)',
        align: 'center',
      },
      colors: [
        '#3B93A5',
        '#F7B844',
        '#ADD8C7',
        '#EC3C65',
        '#CDD7B6',
        '#C1F666',
        '#D43F97',
        '#1E5D8C',
        '#421243',
        '#7F94B0',
        '#EF6537',
        '#C0ADDB',
      ],
      plotOptions: {
        treemap: {
          distributed: true,
          enableShades: false,
        },
      },
    },
  })

  return (
    <div>
      <div id="chart">
        <ReactApexChart
          options={state.options}
          series={state.series}
          type="treemap"
          height={350}
        />
      </div>
    </div>
  )
}

export default ApexChart

Distributed Treemap in Angular

Using ApexCharts with Angular

This Distributed Treemap example wires ApexCharts into Angular through the ng-apexcharts component.

Install it with npm install ng-apexcharts apexcharts, then mount the chart with <apx-chart [series]="series" [chart]="chart"></apx-chart>.

Angular charts guide

This demo uses imperative chart updates. The generated code is a faithful Angular translation: open it in CodeSandbox to run and tweak.

import { Component, AfterViewInit, OnDestroy, ViewChild } from '@angular/core';
import {
  ChartComponent,
  ApexAxisChartSeries,
  ApexNonAxisChartSeries,
  ApexChart,
  ApexXAxis,
  ApexYAxis,
  ApexTitleSubtitle,
  ApexDataLabels,
  ApexStroke,
  ApexFill,
  ApexLegend,
  ApexTooltip,
  ApexMarkers,
  ApexPlotOptions,
  ApexResponsive,
  ApexGrid,
  ApexAnnotations,
  ApexStates,
  ApexTheme,
  NgApexchartsModule,
} from 'ng-apexcharts';

export type ChartOptions = {
  series?: ApexAxisChartSeries | ApexNonAxisChartSeries;
  chart?: ApexChart;
  xaxis?: ApexXAxis;
  yaxis?: ApexYAxis | ApexYAxis[];
  title?: ApexTitleSubtitle;
  subtitle?: ApexTitleSubtitle;
  dataLabels?: ApexDataLabels;
  stroke?: ApexStroke;
  fill?: ApexFill;
  legend?: ApexLegend;
  tooltip?: ApexTooltip;
  markers?: ApexMarkers;
  plotOptions?: ApexPlotOptions;
  responsive?: ApexResponsive[];
  grid?: ApexGrid;
  annotations?: ApexAnnotations;
  states?: ApexStates;
  theme?: ApexTheme;
  colors?: string[];
  labels?: any;
};

@Component({
  selector: 'app-chart',
  standalone: true,
  imports: [NgApexchartsModule],
  templateUrl: './chart.component.html',
})
export class AppChart implements AfterViewInit, OnDestroy {
  @ViewChild('chart') chart!: ChartComponent;
  public chartOptions: Partial<ChartOptions> = {
          series: [
            {
              data: [
                {
                  x: 'node_modules',
                  y: 428,
                },
                {
                  x: 'assets',
                  y: 213,
                },
                {
                  x: '.git',
                  y: 154,
                },
                {
                  x: 'build',
                  y: 96,
                },
                {
                  x: 'vendor',
                  y: 88,
                },
                {
                  x: 'public',
                  y: 61,
                },
                {
                  x: 'src',
                  y: 47,
                },
                {
                  x: 'cache',
                  y: 39,
                },
                {
                  x: 'docs',
                  y: 24,
                },
                {
                  x: 'tests',
                  y: 18,
                },
                {
                  x: 'logs',
                  y: 12,
                },
                {
                  x: 'config',
                  y: 6,
                },
              ],
            },
          ],
          legend: {
            show: false,
          },
          chart: {
            height: 350,
            type: 'treemap',
          },
          title: {
            text: 'Disk Usage by Folder (GB)',
            align: 'center',
          },
          colors: [
            '#3B93A5',
            '#F7B844',
            '#ADD8C7',
            '#EC3C65',
            '#CDD7B6',
            '#C1F666',
            '#D43F97',
            '#1E5D8C',
            '#421243',
            '#7F94B0',
            '#EF6537',
            '#C0ADDB',
          ],
          plotOptions: {
            treemap: {
              distributed: true,
              enableShades: false,
            },
          },
        };
  ngAfterViewInit() {
    (window as any).ApexCharts.setLicense('APEX-eyJleHBpcnlEYXRlIjoiMjEyNi0wNy0wNCIsImlzc3VlRGF0ZSI6IjIwMjYtMDctMjgiLCJwbGFuIjoicHJlbWl1bSIsImRvbWFpbnMiOlsiYXBleGNoYXJ0cy5jb20iLCIxMjcuMC4wLjEiLCJsb2NhbGhvc3QiXSwic2lnIjoieVBmb1VCc0Z3TU9ZdUEyaEZkR0I2Y1FtZ0JITUtXcVdJSjB2NVRESXRZbFR3eDJMUmh6R2x0RUc3VXJ4X0s3b25ZMWRZb2Z2VGItN01ydFYyNDVyOWcifQ==');
  }

  ngOnDestroy() {
    // no cleanup needed
  }
}